-----------------------------------------------------------------------------------------------
--QuickMarks v0.2 for Wildstar
--Author: Infaro
--Date: May 15, 2014
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- QuickMarks Module Definition
-----------------------------------------------------------------------------------------------
local QuickMarks = {} 

 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function QuickMarks:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function QuickMarks:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- QuickMarks OnLoad
-----------------------------------------------------------------------------------------------
function QuickMarks:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("QuickMarks.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- QuickMarks OnDocLoaded
-----------------------------------------------------------------------------------------------
function QuickMarks:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "qmForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("qm", "OnQuickMarksOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- QuickMarks Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/qm"
function QuickMarks:OnQuickMarksOn()
	self.wndMain:Show(true) -- show the window
end


-----------------------------------------------------------------------------------------------
-- QuickMarksForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function QuickMarks:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function QuickMarks:OnCancel()
	self.wndMain:Close() -- hide the window
end


---------------------------------------------------------------------------------------------------
-- qmForm Functions
---------------------------------------------------------------------------------------------------


function QuickMarks:btnBombClick( wndHandler, wndControl, eMouseButton )
local unit = GameLib.GetTargetUnit()
if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(1)
end

function QuickMarks:btnChickenClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(6)	
end

function QuickMarks:btnGhostClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(2)
end

function QuickMarks:btnMaskClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(3)
end

function QuickMarks:btnOctoClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(4)
end

function QuickMarks:btnPigClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(5)
end

function QuickMarks:btnToasterClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(7)
end

function QuickMarks:btnUfoClick( wndHandler, wndControl, eMouseButton )
	local unit = GameLib.GetTargetUnit()
	if unit == nil then return end
	unit:ClearTargetMarker()
	unit:SetTargetMarker(8)
end

function QuickMarks:btnCloseClick( wndHandler, wndControl, eMouseButton )
	self.wndMain:Close()
end

function QuickMarks:btnClearClick( wndHandler, wndControl, eMouseButton )
	GameLib.ClearAllTargetMarkers()
end

-----------------------------------------------------------------------------------------------
-- QuickMarks Instance
-----------------------------------------------------------------------------------------------
local QuickMarksInst = QuickMarks:new()
QuickMarksInst:Init()
